<%@ Page Language="C#" Debug="true" %>
<%@ Import Namespace="System" %>
<%@ Import Namespace="System.Runtime.InteropServices" %>
<%@ Import Namespace="SnapStream.BeyondTV" %>
<%@ Import Namespace="SnapStream.BeyondTV.WebServices" %>
<html>
<head>
  <title>Beyond TV - Record from DigiGuide</title>
  <style>
    body
    {
      background-color:#6376D6;
      font:14px Arial;
    }
  </style>
</head>
<body>

<form id="Form1" method="post" runat="server">
<Script Language="C#" runat="Server" Debug="true">

void Page_load(object sender, System.EventArgs e)
{
  //Pull out the parameters from the submitted request
  string sTitle = Request.Form["Title"].Trim();
  string sDescription = Request.Form["Description"].Trim();
	string sChannel = Request.Form["Channel"].Trim();
	int nDay = System.Convert.ToInt32(Request.Form["Day"]);
	int nMonth = System.Convert.ToInt32(Request.Form["Month"]);
	int nYear = System.Convert.ToInt32(Request.Form["Year"]);
  int nHour = System.Convert.ToInt32(Request.Form["TimeHour"]);
	int nMinute = System.Convert.ToInt32(Request.Form["TimeMinute"]);
	int nAMPM = System.Convert.ToInt32(Request.Form["AMPM"]);
	if (nAMPM == 1) //The hour value is specified in AM/PM format
		nHour += 12;
	int nDurationHour = System.Convert.ToInt32(Request.Form["DurHour"]);
	int nDurationMinute = System.Convert.ToInt32(Request.Form["DurMinute"]);
  int nTotalDuration = (nDurationHour*3600 + nDurationMinute*60);

  //Now create the job properties which we need to specify the recording. The actual
  //values we put in each property were determined by examining the Jobs.xml file
  //which the web interface to Beyond TV generates
  PVSProperty[] newRecordingProps = new PVSProperty[37];
	newRecordingProps[0]  = new PVSProperty("AutoTranscode", "");
	newRecordingProps[1]  = new PVSProperty("Channel", sChannel);
  newRecordingProps[2]  = new PVSProperty("DeleteOnAutoTranscode", "");
	newRecordingProps[3]  = new PVSProperty("DeleteSourceOnTranscode", "");
	newRecordingProps[4]  = new PVSProperty("Description", sDescription);
  newRecordingProps[5]  = new PVSProperty("DisplayedChannelID", sChannel);
	newRecordingProps[6]  = new PVSProperty("DisplayTitle", sTitle);
	newRecordingProps[7]  = new PVSProperty("Duration", Convert.ToString(nTotalDuration) + "0000000");
  newRecordingProps[8]  = new PVSProperty("ExtendEnd", "0");
  newRecordingProps[9]  = new PVSProperty("ExtendStart", "0");
	newRecordingProps[10] = new PVSProperty("FileFormat", "FileFormat NULL");
	newRecordingProps[11] = new PVSProperty("Fixed", "False");
  newRecordingProps[12] = new PVSProperty("GenChapterList", "");
  newRecordingProps[13] = new PVSProperty("GenChapterListDeferred", "");
	newRecordingProps[14] = new PVSProperty("Genre", "None");
	newRecordingProps[15] = new PVSProperty("GUID", System.Guid.NewGuid().ToString());
  newRecordingProps[16] = new PVSProperty("GuidQuality", "");
	newRecordingProps[17] = new PVSProperty("Language", "NULL");
  newRecordingProps[18] = new PVSProperty("ManualRepeat", "Once");
  //Note this code does not bother setting a "MountPointName" property
  newRecordingProps[19] = new PVSProperty("RecordAnyChannel", "False");
  newRecordingProps[20] = new PVSProperty("RequestedVideoDeviceGuid", "");
	newRecordingProps[21] = new PVSProperty("Rules", "Manual");
	newRecordingProps[22] = new PVSProperty("Security", "");
	newRecordingProps[23] = new PVSProperty("TargetDirectoryTranscode", "");
	newRecordingProps[24] = new PVSProperty("TimeParameterDay", Convert.ToString(nDay));
  DateTime dtRecording = new DateTime(nYear, nMonth, nDay);
  newRecordingProps[25] = new PVSProperty("TimeParameterDayOfWeek", Convert.ToString(Convert.ToInt32(dtRecording.DayOfWeek)));
	newRecordingProps[26] = new PVSProperty("TimeParameterHour", Convert.ToString(nHour));
	newRecordingProps[27] = new PVSProperty("TimeParameterMilliseconds", "0");
	newRecordingProps[28] = new PVSProperty("TimeParameterMinute", Convert.ToString(nMinute));
	newRecordingProps[29] = new PVSProperty("TimeParameterMonth", Convert.ToString(nMonth));
	newRecordingProps[30] = new PVSProperty("TimeParameterSecond", "0");
	newRecordingProps[31] = new PVSProperty("TimeParameterYear", Convert.ToString(nYear));
	newRecordingProps[32] = new PVSProperty("Title", sTitle);
	newRecordingProps[33] = new PVSProperty("TranscodeFormat", "");
	newRecordingProps[34] = new PVSProperty("TranscodeQuality", "");
	newRecordingProps[35] = new PVSProperty("UniqueChannelID", "00000" + sChannel + "000000000000");
	newRecordingProps[36] = new PVSProperty("User", "");

  //Create the license manager to allow us to access everything else in BTV
  BTVLicenseManager licManager = new BTVLicenseManager();
  PVSPropertyBag licenseDetails = licManager.Logon("DigiAddClient", "DigiAddClientPassword", "");
  string sAuthTicket = "";
  foreach (PVSProperty prop in licenseDetails.Properties)
  {
    if (prop.Name == "AuthTicket")
      sAuthTicket = prop.Value;
  }

  //Now create a propertybag from the properties array created above
	PVSPropertyBag newRecording = new PVSPropertyBag(newRecordingProps);

  //Pull out the BTV scheduler as we will need it
  BTVScheduler scheduler = new BTVScheduler();

  //This is a boolean which controls additional logging for diagnostic purposes.
  //You are free to change this value to true to get additional info if you need
  //to debug thro the operation of this page
  bool bDisplayAdditionalDetails = false;

  if (bDisplayAdditionalDetails)
  {
    Response.Write("<b>Properties for new recording:</b><br>\n");
    foreach (PVSProperty prop in newRecording.Properties)
    { 
      Response.Write(prop.Name + "=" + prop.Value + "<br>\n");
    }
    Response.Write("<br>\n");

    //Also dump out all the current recordings
    PVSPropertyBag[] currentRecordings = scheduler.GetPossibleRecordings(sAuthTicket);
    Response.Write("<b>Existing Recordings:</b><br>\n");
    foreach (PVSPropertyBag rec in currentRecordings)
    {
      Response.Write("<hr>");
      foreach (PVSProperty prop in rec.Properties)
        Response.Write(prop.Name + " = " + prop.Value + "<br>\n");
    }
    if (currentRecordings.Length == 0)
      Response.Write("None<br>\n");
    Response.Write("<br>\n"); 
  }

  //Next check to see if our new recording will clash with any existing ones
  PVSPropertyBag[] conflictingRecordings = scheduler.GetPotentialConflicts(sAuthTicket, newRecording);
  int nConflictingRecordings = conflictingRecordings.Length;

  //Now try and schedule the new recording if we have no conflicting recordings
  Response.Write("<b>Result:</b><br>\n");
  if (nConflictingRecordings == 0)
  {
    try
    {
      scheduler.AddRecordingJob(sAuthTicket, newRecording, 1);
      Response.Write("The recording was successfully added<br>\n");
    }
    catch(Exception exception)
    {
      Response.Write("An error occurred scheduling the recording, Error:" + exception.ToString() + "<br>\n");
    }
  }
  else
  {
    Response.Write("Unable to schedule the recording due to existing conflicting recordings<br>\n");
    Response.Write("<br><b>Conflicting Recordings:</b><br>\n");
    foreach (PVSPropertyBag rec in conflictingRecordings)
    {
      Response.Write("<hr>");
      foreach (PVSProperty prop in rec.Properties)
        Response.Write(prop.Name + " = " + prop.Value + "<br>\n");
    }
    Response.Write("<br>\n"); 
  }

  //Finally include a link to the main Beyond TV Web interface
  Response.Write("<br>Go to <a href=\"Default.aspx\">Beyond TV Web interface</a><br>\n");
}
</Script>
</form>

</body>
</html>
